/* Mail sorter v.2.0 */
/* Copyright (c)29.11.1996 by Marek Zelem <marek@crazy.elf.stuba.sk> */
/* Copyright (c)24.5.1999 by Marek Zelem <marek@fornax.elf.stuba.sk> */
/* All rights reserved. */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <pwd.h>
#include <ctype.h>
#include <string.h>
#include <regex.h>
#include <mmm/lockfile.h>

#define	BUF_SIZE	8192
//#define	MLOCK_PATH	"/var/spool/mail/.mlock"
char *lockdir=MLOCK_PATH;

int string_to_argv( char *av[], char *s, int max )
{ int i,j,p;
	i=0;
	j=0;
	max-=1;
	while(i<max && s[j]!=0)
	{	while(s[j]==' ' || s[j]=='\t') j++;
		if(s[j]=='\"')
		{ j++;
		  p=j;
		  while(s[j]!='\"' && s[j]!=0) j++;
		}
		else
		{ p=j;
		  while(s[j]!=' ' && s[j]!='\t' && s[j]!=0) j++;
		}
		if(s[j]!=0)
			s[j++]=0;
		av[i++]=s+p;
	}
	av[i]=NULL;
	return(i);
}

char *vyberstr( char *buf, char *h, int cs )
{ int i,j;
// !!!!! ak na novom riadku , tak pokracuje ....
   i=0; j=0;
G_vyberstr:
   if(cs)
   {	for(;j<4096 && h[i]!=0 && h[i]!='\n';)
	{	buf[j++]=h[i++];	}
   }
   else
   {	for(;j<4096 && h[i]!=0 && h[i]!='\n';)
	{	buf[j++]=toupper(h[i++]);	}
   }
   if( h[i]=='\n' && ( h[i+1]=='\t' || h[i+2]==' ' ) )
   { buf[j++]=' '; i+=2; goto G_vyberstr;	}
   buf[j]=0;
   return(buf);
}

/* Vyber adresu z listu */
char *vyberadresu( char *buf, char *h )
{ int i,j;
	j= -2;
	for(i=0;i<1024 && h[i]!=0 && h[i]!='\n';i++)
	{ if(j== -2 && h[i]=='<') j= -1;
	  else if( j== -1 && h[i]!=' ' ) {buf[0]=h[i];j=1;}
	  else if( j>0 && (h[i]==' '|| h[i]=='>') ) {buf[j]=0;j= -3;}
	  else if( j>0 )
		buf[j++]=h[i];
	}
	if(j== -2 || j== -1) j=0;
	if( j>=0 )
		buf[j]=0;
	return(buf);
}

/* ********** process mail ********** */

char home[128];
char name[64];

int ulozene;
int p_data,p_from,p_to,p_cc,p_subject;
char fnh[128],fnt[128],fna[128],fn[128];
char *mail=NULL;
int mailsize=0;

char *f_p=NULL,f_c;
char *get_field( char where )
{ char *p;
	switch(where)
	{
		case 'h':	f_p=mail+p_data;
				f_c=*f_p; *f_p=0;
				return(mail);
		case 't':	f_p=NULL;
				return(mail+p_data);
		case 'a':	f_p=NULL;
				return(mail);
		case 'F':	p=mail+p_from;		break;
		case 'T':	p=mail+p_to;		break;
		case 'C':	p=mail+p_cc;		break;
		case 'S':	p=mail+p_subject;	break;
	}
	f_p=NULL;
	if( p < mail )	return("");
	f_p=p;
	while( *f_p!=0 && !(*f_p=='\n' && f_p[1]!='\t' && f_p[1]!=' ') )
		f_p++;
	f_c=*f_p; *f_p=0;
	return(p);
}

void unget_field( void )
{	if( f_p!=NULL )	*f_p=f_c;
	f_p=NULL;
}

int match( char *regexp, int flags, char where )
{ regex_t preg;
  int r;
  	if( mail==NULL )	return(0);
	if( (r=regcomp(&preg,regexp,flags)) )
		return(0);	/* error */
	if( (r=regexec(&preg,get_field(where),0,NULL,0)) &&
		r!=REG_NOMATCH )
	{	unget_field();
		return(0);	/* error */
	}
	unget_field();
	regfree(&preg);
	if( r==0 )	return(1);
	return(0);
}

int writemail( char *file );
int forwardmail( char *to );
int pipemail( char where, char *prog );

void do_config( FILE *f )
{ char buf[1024];
  int yes,level;   /*yes: 0-nie(testuj), 1-vykonaj(testuj), 2-ano(netestuj)*/
  int i,flags,not;
  char where;
  	yes=1; level=0;
	while( fgets(buf,1024,f)!=NULL )
	{	if( buf[0]!=0 && buf[strlen(buf)-1]=='\n' )
			buf[strlen(buf)-1]=0;
		if( !strncmp(buf,"#include ",9) )
		{ FILE *g;
			if( (g=fopen(buf+9,"r"))!=NULL )
			{	do_config(g);
				fclose(g);
			}
			continue;
		}
		if( buf[0]=='#' )	continue;
		if( buf[0]=='.' && yes )	return;
		if( buf[0]==0 || buf[0]=='.' || buf[0]==';' )
		{	yes=1; continue;	}
		if( buf[0]=='{' )
		{	if( yes )	{	do_config(f);
						yes=1;
					}
			else		level++; 
			continue;
		}
		if( buf[0]=='}' )
		{	if( yes )	return;
			if( level<=0 )	return;
			level--;
			continue;
		}
		if( buf[0]=='/' || (buf[0]=='&' && buf[1]=='/') )
		{	if( buf[0]=='&' )
			{	if( !yes )	continue;
				i=2;
			} else
			{	if( yes==2 )	continue;
				i=1;
			}
			for(;buf[i]!=0;i++)
			{	if( buf[i]=='\\' && buf[i+1]!=0 )
				{	if( buf[i+1]=='/' )
						strcpy(buf+i,buf+i+1);
					else	i++;
					continue;
				}
				if( buf[i]=='/' ) break;
			}
			flags=REG_EXTENDED|REG_ICASE|REG_NOSUB;
			where='h'; not=0;
			if( buf[i]=='/' )
			{	buf[i++]=0;
				for(;buf[i]!=0;i++)
				{	switch( buf[i] )
					{	case 'i': flags|=REG_ICASE;
							  break;
						case 'c': flags&=~REG_ICASE;
							  break;
						case 'h':
						case 't':
						case 'a':
						case 'F':
						case 'T':
						case 'C':
						case 'S': where=buf[i];
							  break;
						case '!': not=1;
							  break;
					}
				}
			}
			if( match(strchr(buf,'/')+1,flags,where) )
							yes = !not;
			else				yes = not;
			if( yes )	yes=2;
			continue;
		}
		if( !yes )	continue;
		yes=1;	/* aby prikaz ukoncoval blok or-podmienok */
		if( buf[0]=='-' )	writemail(buf+1);
		else if( buf[0]=='%' )	writemail("");
		else if( buf[0]=='@' )	forwardmail(buf+1);
		else if( buf[0]=='|' )	pipemail('a',buf+1);
		else if( buf[0]=='h' && buf[1]=='|' )	pipemail('h',buf+2);
		else if( buf[0]=='t' && buf[1]=='|' )	pipemail('t',buf+2);
		else if( buf[0]=='a' && buf[1]=='|' )	pipemail('a',buf+2);
	}
	return;
}

void proces_mail( void )
{ 
  int is_head;
  int fdh,fdt,fda,l;
  char buf[BUF_SIZE+4];
  char *p;
  FILE *f;
	
   mail=NULL; mailsize=0;
   p_from=p_to=p_cc=p_subject=-1;
   ulozene=0;
   is_head=1;

   sprintf(fnh,"%s/%s.%d.head",lockdir,name,getpid());
   sprintf(fnt,"%s/%s.%d.text",lockdir,name,getpid());
   sprintf(fna,"%s/%s.%d.all",lockdir,name,getpid());
   fdh=open(fnh,O_WRONLY|O_CREAT|O_TRUNC,0600);
   fdt=open(fnt,O_WRONLY|O_CREAT|O_TRUNC,0600);
   fda=open(fna,O_WRONLY|O_CREAT|O_TRUNC,0600);
   if( fdh<0 || fdt<0 || fda<0 )
	   return;	/* fatal("Can't create tmp files\n"); */
	   
   while( (l=read(0,buf,BUF_SIZE))>0 )
   {	if( is_head )
   	{	buf[l]=0;
		if( (p=strstr(buf,"\nFrom: "))!=NULL )	p_from=p-buf+7;
		if( (p=strstr(buf,"\nTo: "))!=NULL )	p_to=p-buf+5;
		if( (p=strstr(buf,"\nCc: "))!=NULL )	p_cc=p-buf+5;
		if( p_cc<0 && (p=strstr(buf,"\ncc: "))!=NULL )	p_cc=p-buf+5;
		if( (p=strstr(buf,"\nSubject: "))!=NULL ) p_subject=p-buf+10;
		if( (p=strstr(buf,"\n\n"))!=NULL )
		{	p_data=p-buf+2;
			write(fdh,buf,p_data);
			write(fdt,p+2,l-p_data);
		}
		else {	p_data=l;
			write(fdh,buf,l);
		}
		is_head=0;
	}
	else	write(fdt,buf,l);
	write(fda,buf,l);
	if( mail==NULL && mailsize>0 ) continue;
	if( (mail=realloc(mail,mailsize+l+2))!=NULL )
	{	memcpy(mail+mailsize,buf,l);
		mailsize+=l; mail[mailsize]='\n'; mail[mailsize+1]=0;
	}
   }
   close(fdh); close(fdt); close(fda);

/* Teraz je mail rozdeleny: fnh -hlavicka, fnt -obsah, fna -cely */

   if( mail!=NULL )
   {
   	sprintf(fn,"%s/.mailsortrc",home);
   	if( (f=fopen(fn,"r"))!=NULL )
   	{	do_config(f);
   		fclose(f);
   	}
   }

   if(ulozene<=0)	writemail("UNSORTED_MAIL");
   if(ulozene<=0)	/* posledny pokus o ulozenie mailu */
   {	sprintf(buf,"%s/UNSORTED_MAIL.%s",MLOCK_PATH,name);
	writemail(buf);
   }
   if(ulozene<=0)	writemail("");	/* ked vsetko zlyha skus inbox */
   if(ulozene<=0)	/* ak neide ani inbox, skus /tmp */
   {	sprintf(buf,"/tmp/UNSORTED_MAIL.%s",name);
	writemail(buf);
   }

   unlink(fnh);
   unlink(fnt);
   unlink(fna);
   return;
}

int writemail( char *file )
{ int fd,rfd;
  char fn[128];
	if( file[0]=='/' )	sprintf(fn,"%s",file);
	else if( file[0]==0 )	sprintf(fn,"/var/spool/mail/%s",name);
	else			sprintf(fn,"%s/%s",home,file);
	if( (fd=open(fn,O_WRONLY|O_APPEND|O_CREAT,0600))>=0 )
	{	if( mail!=NULL )
			write(fd,mail,mailsize+1);
		else
		{ char buf[8192];
		  int l;
			if( (rfd=open(fna,O_RDONLY)) )
			{	while( (l=read(rfd,buf,8192))>0 )
					write(fd,buf,l);
				write(fd,"\n",1);
				close(rfd);
			}
		}
		close(fd);
		ulozene++;
	}
	return(0);
}

int forwardmail( char *to )
{ char email[128];
  int fd,x;
  int status;
	strcpy(email,to);
	if( (fd=open(fna,O_RDONLY,0))>=0 )
	{	if( (x=fork())==0 )
		{ char buf[64];
		  char *av[16];
			close(0);
			dup2(fd,0);
			strcpy(buf,"/usr/bin/sendmail");
			av[0]=buf;
			string_to_argv(av+1,email,15);
			execv(buf,av);
		}
		else if( x>0 ) ulozene++;
		wait(&status);
	}
	return(0);
}

int pipemail( char where, char *prog )
{ char *fn;
  int reply=1;
  int fd,p[2];
  char *av[16];
  char reply_to[128];
  char pom[4096];
  int status;
	if( mail==NULL )	return(-1);
	switch(where)
	{	case 'h':	fn=fnh;	break;
		case 't':	fn=fnt;	break;
		case 'a':	fn=fna;	break;
		default:	return(-1);
	}
	if( prog[0]=='\\' )
	{	reply=0;	prog++;		}

	if( p_from<0 )	reply=0;
	else		vyberadresu(reply_to,mail+p_from);

	if( (fd=open(fn,O_RDONLY,0))>=0 )
	{	pipe(p);
		if( fork()==0 )
		{ close(0);
		  dup2(fd,0);
		  close(1);
		  dup2(p[1],1);
		  if( p_from>=0 )
		  	setenv("FROM",reply_to,1);
		  if( p_to>=0 )
		  	setenv("TO",vyberstr(pom,mail+p_to,1),1);
		  if( p_cc>=0 )
		  	setenv("CC",vyberstr(pom,mail+p_cc,1),1);
		  if( p_subject>=0 )
		  	setenv("SUBJECT",vyberstr(pom,mail+p_subject,1),1);
//		  setenv("DATE",vyberstr(pom,mail+p_date,1),1);
		  setenv("NAME",name,1);
		  setenv("HOME",home,1);
		  string_to_argv(av,prog,16);
		  execv(av[0],av);
		}
		ulozene++;
		if( reply && fork()==0 )
		{ close(0);
		  dup2(p[0],0);
		  strcpy(pom,"/usr/bin/sendmail");
		/*		  strcpy(pom,"/bin/mail");	*/
		  av[0]=pom;
		  av[1]=reply_to;
		  av[2]=NULL;
		  execv(pom,av);
		}
		else if( reply )	ulozene--;
		wait(&status);
		close(p[0]); close(p[1]); close(fd);
	}
	return(0);
}


int main( int argc, char *argv[] )
{ struct passwd *p;
  char fname[128];

	if( (p=getpwuid(getuid()))==NULL )      return(-1);
	strcpy(name,p->pw_name);
	strcpy(home,p->pw_dir);

	sprintf(fname,"%s.%d",name,getuid());
	if( create_lockfile((lockdir=MLOCK_PATH),fname,-1)<0 )
		if( create_lockfile((lockdir="/tmp"),fname,-1)<0 )
			return(-1);

/*  Tato cast bezi v jednom okamihu len raz pre jedneho uzivatela  */

	proces_mail();

/*  Uvolnenie miesta dalsim  */

	delete_lockfile(lockdir,fname);
	return(0);
}

